#include	<QPushButton>
#include	<QThread>
#include	<QTime>
#include	"mainwindowimpl.h"
#include	"displaywidget.h"
#include	"commthread.h"
#include	"dso.h"
#include <time.h>

extern	Dso   *dso;
//
CommThread::CommThread(QWidget * parent) 	//QDevelop
{
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
	displayWidget=parent;
}

void	CommThread::thControl()
{
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
	if (isRunning()) {
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
		thRun=false;
	}
	else {
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
		thRun=true;
		start();
	}
}

//
// Called when thread is started
//
void	CommThread::run()
{
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);

	dso->init();

	exec();
}

void CommThread::handleReport(unsigned char* buffer, int bufsize) {
int	idx=0;
    int	Selected_Voltage_CH1=buffer[idx++];
    int	Selected_Voltage_CH2=buffer[idx++];
    int	Selected_Voltage_CH3=buffer[idx++];
    int	Selected_Voltage_CH4=buffer[idx++];
    int	Virtual_ZeroLevelCH1=buffer[idx++];
    int	Virtual_ZeroLevelCH2=buffer[idx++];
    int	Virtual_ZeroLevelCH3=buffer[idx++];
    int	Virtual_ZeroLevelCH4=buffer[idx++];
    int	ZeroLevelCH1=buffer[idx++];
    int	ZeroLevelCH2=buffer[idx++];
    int	ZeroLevelCH3=buffer[idx++];
    int	ZeroLevelCH4=buffer[idx++];
    int	Trigger_Pos_CH1=buffer[idx++];
    int	Trigger_Pos_CH2=buffer[idx++];
    int	Trigger_Pos_CH3=buffer[idx++];
    int	Trigger_Pos_CH4=buffer[idx++];
    int	Trigger_Pos_CHE=buffer[idx++];
    int	Trigger_Offset_Pos=buffer[idx++];
    int	Selected_Timebase=buffer[idx++];

	printf("CommThread::handleReport: Selected_Voltage_CH1: %d \
    Selected_Voltage_CH2: %d  \
    Selected_Voltage_CH3: %d  \
    Selected_Voltage_CH4: %d  \
    Virtual_ZeroLevelCH1: %d  \
    Virtual_ZeroLevelCH2: %d  \
    Virtual_ZeroLevelCH3: %d  \
    Virtual_ZeroLevelCH4: %d  \
    ZeroLevelCH1: %d  \
    ZeroLevelCH2: %d  \
    ZeroLevelCH3: %d  \
    ZeroLevelCH4: %d  \
    Trigger_Pos_CH1: %d  \
    Trigger_Pos_CH2: %d  \
    Trigger_Pos_CH3: %d  \
    Trigger_Pos_CH4: %d  \
    Trigger_Pos_CHE: %d  \
    Trigger_Offset_Pos: %d  \
    Selected_Timebase: %d \n", Selected_Voltage_CH2, Selected_Voltage_CH3, Selected_Voltage_CH4, Virtual_ZeroLevelCH1, Virtual_ZeroLevelCH2, Virtual_ZeroLevelCH3, Virtual_ZeroLevelCH4, ZeroLevelCH1, ZeroLevelCH2, ZeroLevelCH3, ZeroLevelCH4, Trigger_Pos_CH1, Trigger_Pos_CH2, Trigger_Pos_CH3, Trigger_Pos_CH4, Trigger_Pos_CHE, Trigger_Offset_Pos, Selected_Timebase);


}

void CommThread::handleData(unsigned char* buffer, int bufsize) {
	int	nchan=*buffer++;
	for (int chan=0;chan<nchan;chan++) {
		int	c=*buffer++;
		for (int x=0;x<=bufsize/nchan;x++) {
			dso->dsoData[chan][x]=*buffer++;
		}
	}
	emit (displayWidget->update());
}

void	CommThread::exec() {
#define	RXBUFSIZE	512

QTime timeouttimer,dataTimer;

unsigned static char rxchar;
unsigned static char rxbuf[RXBUFSIZE];
unsigned char *dataBuffer;

int	count,cmdlen,cmd,rxcnt,idx;

	rxstat = WAIT_FOR_STX;

	dataTimer.start();
	while(thRun) {
		idx=0;
		if (rxstat!=WAIT_FOR_STX && timeouttimer.elapsed() > 500) {
			printf ("***** Timeout! *****\n");
			dso->waitingAnswer=false;
			rxstat=WAIT_FOR_STX; }

		while((count=read(dso->dsofd,&rxchar,1))>0)
		{
// if (isprint(rxchar)) printf("%c",rxchar); else printf("<%.2X>",rxchar);
			switch(rxstat) {
			case WAIT_FOR_STX:
				if (idx < RXBUFSIZE) { rxbuf[idx++]=rxchar; }
				if (rxchar==0x02) { 
					rxstat=WAIT_FOR_CMD;
					timeouttimer.start();
					printf("STX received\n");
					}
				break;
			case WAIT_FOR_CMD:
				cmd=rxchar;
				rxstat=WAIT_FOR_LEN_LSB;
				printf("CMD received. CMD: %d\n",cmd);
				rxcnt=0;
				break;
			case WAIT_FOR_LEN_LSB:
				cmdlen=rxchar;
				rxstat=WAIT_FOR_LEN_MSB;
				printf("LEN_LSB received :%d\n",cmdlen);
				break;
			case WAIT_FOR_LEN_MSB:
				cmdlen+=rxchar<<8;
				rxstat=WAIT_FOR_ETX;
				printf("LEN_MSB received. CMDLEN: %d\n",cmdlen);
				dataBuffer=(unsigned char *)malloc(cmdlen);
				break;
			case WAIT_FOR_ETX:
				timeouttimer.start();
				dataBuffer[rxcnt]=rxchar;
				if (rxcnt++==cmdlen) rxstat=WAIT_FOR_CSUM;
				break;
			case WAIT_FOR_CSUM:
				if (rxchar==0x03) {
					rxstat=WAIT_FOR_STX;
					dso->waitingAnswer=false;
					printf("CMD %.2X complete.\n",cmd);
//Handle command
					switch(cmd) {
						case	'R':
						handleReport(dataBuffer,cmdlen);
						break;
						case	0x44:
						handleData(dataBuffer,cmdlen);
						break;
					}
					free(dataBuffer);
				}
				break;
			}
		}
		printf("%s (%s:%d) timeBase: %d CH1: %d CH2: %d Count: %d\n",
			__func__,__FILE__,__LINE__,
			dso->getTimeBase(),dso->getVertSens(1),dso->getVertSens(2),count);

		if (idx > 0) emit (serialDataRx(idx, rxbuf));

		if (dso->dsoChanged && dso->waitingAnswer) 
			printf("*********** dso->dsoChanged && dso->waitingAnswer******\n");

		if (rxstat==WAIT_FOR_STX) { // && dso->waitingAnswer== false) {
			if (dso->NeedSettings) {
				requestSettings(dso->dsofd); }
			else if (dso->dsoChanged & dsoChangedVert) {
				setVertRes(dso->dsofd,
				dso->getVertSens(1), dso->getVertSens(2), dso->getVertSens(3), dso->getVertSens(4));
				dso->dsoChanged &= ~dsoChangedVert;
			}
			else if (dso->dsoChanged & dsoChangedTB) {
				setTimeBase(dso->dsofd, dso->getTimeBase());
				dso->dsoChanged &= ~dsoChangedTB;
			}
			else {
				sendGetData(dso->dsofd);
				dataTimer.start();
			}
		}
	}
}

void    CommThread::requestSettings(int dsoFd) {
unsigned static char sendbuffer[64];
int idx=0;
	sendbuffer[idx++]=2;
	sendbuffer[idx++]=0;
	sendbuffer[idx++]=0;
	sendbuffer[idx++]='R';
	sendbuffer[idx++]=3;
	sendbuffer[idx++]=3;
	write(dsoFd,sendbuffer, idx);

	dso->NeedSettings=false;
}

void    CommThread::setTimeBase(int dsoFd, int value) {
unsigned static char sendbuffer[64];
int idx=0;
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
	dso->waitingAnswer=true;
	sendbuffer[idx++]=2;
	sendbuffer[idx++]=2;
	sendbuffer[idx++]=0;
	sendbuffer[idx++]='S';
	sendbuffer[idx++]='H';
	sendbuffer[idx++]=value+3;
	sendbuffer[idx++]=3;
	sendbuffer[idx++]=3;

	write(dsoFd,sendbuffer, idx);
}

void    CommThread::setVertRes(int dsoFd, int value1, int value2, int value3, int value4) {
unsigned static char sendbuffer[64];
int idx=0;
	dso->waitingAnswer=true;
	sendbuffer[idx++]=2;
	sendbuffer[idx++]=5;
	sendbuffer[idx++]=0;
	sendbuffer[idx++]='S';
	sendbuffer[idx++]='V';
	sendbuffer[idx++]=value1+3;
	sendbuffer[idx++]=value2+3;
	sendbuffer[idx++]=value3+3;
	sendbuffer[idx++]=value4+3;
	sendbuffer[idx++]=3;
	sendbuffer[idx++]=3;

	write(dsoFd,sendbuffer, idx);
}

void    CommThread::sendGetData(int	dsoFd) {
unsigned static char sendbuffer[64];
int	scale=6;
int idx=0;
	dso->waitingAnswer=true;
	sendbuffer[idx++]=2;
	sendbuffer[idx++]=7;
	sendbuffer[idx++]=0;
	sendbuffer[idx++]='D';
	sendbuffer[idx++]=3;
	sendbuffer[idx++]=0;
	sendbuffer[idx++]=0;
	sendbuffer[idx++]=(640*scale)&255;
	sendbuffer[idx++]=(640*scale)>>8;
	sendbuffer[idx++]=scale;	//Step
	sendbuffer[idx++]=0;
	sendbuffer[idx++]=3;

	write(dsoFd,sendbuffer, idx);
}
