#ifndef COMMTHREAD_H
#define COMMTHREAD_H
//
#include <QThread>
#include <QMainWindow>
#include "dso.h"
#include "ui_mainwindow.h"
//
class CommThread : public QThread
{
Q_OBJECT
public:
	CommThread( QWidget * parent = 0);
	void	run();
	void	stop();
	QWidget *displayWidget;

	void	requestSettings(int);
//public slots:
	void	setVertRes(int, int, int,int,int);
	void	setTimeBase(int, int);
private slots:
	void	thControl();
	void	exec();
signals:
	void	serialDataRx(int count, unsigned char *buffer);
private:
	bool	thRun;
	void	handleData(unsigned char *, int);
	void	handleReport(unsigned char *, int);
	void	sendGetData(int);

enum rxstat_t {
    WAIT_FOR_STX = 0,
    WAIT_FOR_CMD,
    WAIT_FOR_LEN_LSB,
    WAIT_FOR_LEN_MSB,
    WAIT_FOR_ETX,
    WAIT_FOR_CSUM,
    RXREADY,
    RXERROR } rxstat;

};
#endif
