#include	<QPainter>
#include <QFrame>
#include	<QPaintEvent>
#include	"displaywidget.h"
#include	"dso.h"

extern  Dso   *dso;
//
DisplayWidget::DisplayWidget( QWidget * parent) 	//QDevelop
	: QFrame(parent)
{
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
	setBackgroundRole(QPalette::Dark);
	setFrameStyle(QFrame::Panel | QFrame::Sunken);
	setParent(parent);
	setAutoFillBackground(true);
	setToolTip("Tooltip2");
	resize(640,480);
	move(0,20);
}

void	DisplayWidget::update() {
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
	printf("DisplayWidget::update()\n");
	setToolTip("Tooltip2");
}

void	DisplayWidget::render() {
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
	printf("DisplayWidget::render()\n");
	setToolTip("Tooltip2");
}

QSize	sizeHint() {
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
	printf("DisplayWidget::sizeHint()\n");
    return QSize(640,480);
}

void	DisplayWidget::repaint() {
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
	printf("DisplayWidget::repaint()\n");
	setToolTip("Tooltip2");
}

void DisplayWidget::paintEvent(QPaintEvent * /* event */)
{
	QColor chanColor[]={QColor(255, 255, 0),QColor(0, 255, 0),QColor(255, 0, 0),QColor(0, 0, 255)};

	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
    QPainter painter(this);
	printf("DisplayWidget::paintEvent()\n");
    painter.fillRect(0,0,640,480, Qt::black);

	QPen horizPen(QColor(127,127,127));
	
	QVector<qreal> dashes;
    dashes << 2 << 12;
    horizPen.setDashPattern(dashes);
	painter.setPen(horizPen);

	for (int y=0; y<480; y+=48) {
		painter.drawLine(0, y, 640, y); }

	for (int x=0; x<640; x+=48) {
		painter.drawLine(x, 0, x, 480); }

	for (int chan=0; chan<2; chan++) {
		painter.setPen(chanColor[chan]);
		for (int x=1;x<16384;x++) {
			painter.drawLine(x,dso->dsoData[chan][x-1]*2,
							 x+1,dso->dsoData[chan][x]*2); }}
}
