#include	<QString>
#include	<stdio.h>
#include <iostream>
#include <fcntl.h>
#include <termios.h>
#include	"dso.h"

extern	Dso	*dso;

Dso::Dso() {
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
	dsoChanged=0;
	resolutions << "10mV"<<  "20mV"<<  "50mV"<< "100mV"<<  "200mV"<<  "500mV"<< "1V"<<  "2V"<<  "5V" ;
	timeBases << "5ns" << "10ns" << "20ns" << "50ns" << "100ns" << "200ns" << "500ns" << "1us" << "2us" << "5us" << "10us" << "20us" << "50us" << "100us" << "200us" << "500us" << "1ms" << "2ms" << "5ms" << "10ms" << "20ms" << "50ms" << "100ms" << "200ms" << "500ms" << "1s" << "2s" << "5s" << "10s" << "20s";
}

Dso::~Dso() {
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
}

int	Dso::connect(char * devname) {
static  termios save_termios, termios_neu;
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);

	int fd=open(devname,O_RDWR);
	if (fd < 0) return(fd);
    tcgetattr(fd,&save_termios);
    tcgetattr(fd,&termios_neu);
    termios_neu.c_iflag =  IXON | IXANY | IGNBRK | IGNPAR;
    termios_neu.c_oflag = 0;
    termios_neu.c_cflag = (CLOCAL | B115200 | CS8 | CREAD );
    termios_neu.c_lflag = ~(ICANON | ECHO | ICRNL | ISIG);
    termios_neu.c_cc [VINTR] = 0;
    termios_neu.c_cc [VQUIT] = 0;
    termios_neu.c_cc [VERASE] = 0;
    termios_neu.c_cc [VKILL] = 0;
    termios_neu.c_cc [VMIN] = 0;
    termios_neu.c_cc [VTIME] = 1;
    termios_neu.c_cc [VSWTC] = 1;
    printf("%s(%d)\n",__FILE__,__LINE__);
    tcsetattr(fd,TCSANOW,&termios_neu);

    return(fd);

	return(0);
}

int	Dso::init() {
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);

	return(0);
}

int	Dso::setVertSens(int channel, int sens) {
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
	vertSens[channel]=sens;
	dso->dsoChanged|=dsoChangedVert;
	return(0);
}

int	Dso::getTimeBase() {
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
	return(timeBase);
}

int	Dso::setTimeBase(int sens) {
	printf("%s (%s:%d)\n",__func__,__FILE__,__LINE__);
	timeBase=sens;
	dso->dsoChanged|=dsoChangedTB;
	return(0);
}

QString	Dso::getVertSensStr(int index) {
	cout << "Dso::getVertSensStr( " << index <<") : " << resolutions.at(index).toLocal8Bit().constData() << endl;
	return(resolutions.at(index).toLocal8Bit().constData());
}

int	Dso::getVertSens(int index) {
	return(vertSens[index]);
}

QString	Dso::getTimBaseText(int index) {
	cout << "Dso::getVertSensStr( " << index <<") : " << timeBases.at(index).toLocal8Bit().constData() << endl;
	return(timeBases.at(index).toLocal8Bit().constData());
}

int Dso::getNumberTimeBases() {
	return(Dso::timeBases.size());
}

void	Dso::setNeedSettings() {
	NeedSettings=true; }

void	Dso::reSetNeedSettings() {
	NeedSettings=false; }
