#include <QtGui>
#include <QApplication>
#include <QPushButton>
#include <QWidget>
#include <QFont>

#include <QMessageBox>
#include <fcntl.h>
#include <termios.h>
#include "renderarea.h"
#include "window.h"
#include <math.h>

//Fülle den globalen Puffer für Daten aus dem Scope vorerst mit Zufallszahlen

extern unsigned char buffer[2][16384];
struct termios save_termios;

int get_data(int fd, QWidget *widget) {
	unsigned char	c,chan,cmd;
	int		nchannels,bufsize,count=0,n=0;
	int	scale=1;

	printf("get_data\n");

	while(read(fd,&c,1)>0) {printf ("%c",c); };

	printf("Los geht's\n");
//STX
	c=2; count=write(fd,&c,1); read(fd,&c,1); printf("0: %c\n",c);
//LEN
	c=7; count=write(fd,&c,1); read(fd,&c,1); printf("2: %c\n",c);
	c=0	; count=write(fd,&c,1); read(fd,&c,1); printf("2: %c\n",c);
//CMD
	c='D'; count=write(fd,&c,1); read(fd,&c,1); printf("1: %c\n",c);
//Channelmask
	c=3; count=write(fd,&c,1); read(fd,&c,1); printf("2: %c\n",c);
//START
	c=0; count=write(fd,&c,1); read(fd,&c,1); printf("2: %c\n",c);
	c=0; count=write(fd,&c,1); read(fd,&c,1); printf("3: %c\n",c);
//STOP
	c=(640*scale)&255; count=write(fd,&c,1); read(fd,&c,1); printf("2: %.2X\n",c);
	c=(640*scale)>>8; count=write(fd,&c,1); read(fd,&c,1); printf("3: %.2X\n",c);
//STEP
	c=1; count=write(fd,&c,1); read(fd,&c,1); printf("2: %c\n",c);
	c=0; count=write(fd,&c,1); read(fd,&c,1); printf("3: %c\n",c);
//ETX
	c=3; count=write(fd,&c,1); read(fd,&c,1); printf("4: %c\n",c);
//ETX nochmal, wg. FW-Fehler
	c=3; count=write(fd,&c,1); read(fd,&c,1); printf("4: %c\n",c);
//Wait for STX
	printf("Wait 0x2\n");
	int tmout=0;
	do {
		count=read(fd,&c,1);
		if (!count) tmout++; 
		else printf ("%c",c); n++;
	} while (c != 0x02 && tmout<50);
	if (c!=0x02) {
		return(-1);
	}
	read(fd,&cmd,1);
	printf ("CMD: %c(%.2X) ",cmd,cmd);
	if (cmd=='e') {
		while(!read(fd,&c,1));
		printf("Error: %d\n",c);
		return(-1);
	}
	read(fd,&c,1); nchannels=c;
	read(fd,&c,1); bufsize=c;
	read(fd,&c,1); bufsize+=(c<<8);
	printf("Bufsize %d: NCHAN: %d\n",bufsize,nchannels);
	for (int i=0; i<nchannels;i++) {
		read(fd,&chan,1); 
		printf("Chan: %d Bufsize %d\n",chan,bufsize);
		n=0;
		while(((count=read(fd,&c,1))>0) && (n<bufsize/2)) {
			buffer[chan][n]=c;
			printf(" %d ",c);
			n++;
		}
		printf("\n%d Bytes gelesen\n",n);
	}
//	while(read(fd,&c,1)>0) {printf ("%c",c); };

	return(bufsize);
}

int openscope(char *devname) {

static	termios termios_neu;
	
	int	fd=open(devname,O_RDWR);
	if (fd < 0) return(fd);
	
	tcgetattr(fd,&save_termios);
	tcgetattr(fd,&termios_neu);
	termios_neu.c_iflag =  IXON | IXANY | IGNBRK | IGNPAR;
	termios_neu.c_oflag = 0;
	termios_neu.c_cflag = (CLOCAL | B115200 | CS8 | CREAD );
	termios_neu.c_lflag = ~(ICANON | ECHO | ICRNL | ISIG);
	termios_neu.c_cc [VINTR] = 0;
	termios_neu.c_cc [VQUIT] = 0;
	termios_neu.c_cc [VERASE] = 0;
	termios_neu.c_cc [VKILL] = 0;
	termios_neu.c_cc [VMIN] = 0;
	termios_neu.c_cc [VTIME] = 1;
	termios_neu.c_cc [VSWTC] = 1;
	printf("%s(%d)\n",__FILE__,__LINE__);
	tcsetattr(fd,TCSANOW,&termios_neu);
		
	return(fd);
}

char	*checkscope(int fd) {
	char	c;
	int		count,n=0;
	while((count=read(fd,&c,1))>0) {
		n++;
	}
	printf("%d Bytes gelesen\n",n);
}
