#ifndef MAINWINDOWIMPL_H
#define MAINWINDOWIMPL_H
//
#include <QMainWindow>
#include <QTextEdit>
#include "dso.h"
#include "commthread.h"
#include "displaywidget.h"
#include "ui_mainwindow.h"
//

class MainWindowImpl : public QMainWindow, public Ui::MainWindow
{
Q_OBJECT
public:
	MainWindowImpl( QWidget * parent = 0, Qt::WFlags f = 0 );
	void	update();
	void	repaint();

private:
	CommThread  *commThread;
	QAction *openAction;
	QAction *quitAction;
	QAction *editPrefsAction;
	void setUpSliders();
	void setUpMenu();
	QMenu * fileMenu;
	QMenu * editMenu;
	QTextEdit *editor;

public slots:
	void	quit();
	void	thStarted();
	void	thStopped();
	void	vertResChange1(int);
	void	vertResChange2(int);
	void	timeBaseChanged(int);
	int		open();
	void	editPrefs();
	void	serialDataRx(int, unsigned char *buffer);
	void	setNeedSettings();
};
#endif




